/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: toppers_atk2.c 919 2014-01-09 11:19:14Z fsi-asanoto $
 */

#include "Os.h"
#include "t_syslog.h"
#include "t_stdlib.h"
#include "sysmod/serial.h"
#include "sysmod/syslog.h"
#include "toppers_atk2.h"

#include "sysmod/banner.h"
#include "target_sysmod.h"
#include "target_serial.h"

#include "device.h"

/*
 *  ؿץȥ
 */
sint32 main(void);

TASK(dsw_task);


/*
 *  桼ᥤؿ
 *
 *  ץꥱ⡼ɤȽǤȡͥ뵯ư
 */
sint32
main(void){
	/*
	 *  ͥ뵯ư
	 */
	StartOS(AppMode1);

	while(1){
	}
}   /* main */


/*
 *  ȥåץեå롼
 */
#ifdef CFG_USE_STARTUPHOOK
void
StartupHook(void){
	/* ƥǽν */
	syslog_initialize();

	/* Ϥν */
	syslog_msk_log(LOG_UPTO(LOG_INFO));

	/* ꥢIO⥸塼 */
	InitSerial();

	/* ͥ뵯ưåν */
	print_banner();

	/* LED */
	led_init();

	/* DSW */
	switch_dip_init();

	/* PSW */
	switch_push_init();

}   /* StartupHook */
#endif /* CFG_USE_STARTUPHOOK */


/*
 *  dsw_task(LEDǥ)
 */
TASK(dsw_task){
	uint8 led_state;
	uint8 dsw_state;
	uint8 pre_dsw_state = 0;
	uint8 psw_state;
	uint8 pre_psw_state = 0;

	syslog(LOG_INFO, "dsw_tsk Start!");

	for(;;) {
		/* DSWּ */
		dsw_state = switch_dip_sense();

		/* ѲȽ */
		if(dsw_state != pre_dsw_state){
			/* Ѳ֤¸ */
			pre_dsw_state = dsw_state;
			led_state = 0;

			/* ƥӥåȤξȽ */
			if((dsw_state & DSW1) == DSW1){
				led_state |= LED1;
			}

			if((dsw_state & DSW2) == DSW2){
				led_state |= LED2;
			}

			if((dsw_state & DSW3) == DSW3){
				led_state |= LED3;
			}

			if((dsw_state & DSW4) == DSW4){
				led_state |= LED4;
			}

			/* LED */
			led_out(led_state);

			/*  */
			syslog(LOG_INFO, "DipSwitch State = 0x0%x", dsw_state);
			syslog(LOG_INFO, "LED State       = 0x0%x", led_state);
		}

		/* PSWξּ */
		psw_state = switch_push_sense();

		/* ѲȽ */
		if(psw_state != pre_psw_state){
			syslog(LOG_INFO, "PSW State Change = 0x0%x to 0x0%x", pre_psw_state, psw_state);

			pre_psw_state = psw_state;
		}
	}

}	/* TASK( dsw_task ) */
